diff --git a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
index f161b7d88..3971b38eb 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -82,11 +82,11 @@ public abstract class Player
     public static final int DATA_SELECTED_ART = 17;
     public static final int DATA_HELD_ARROW = 18;
     public static final TextFormatting deathMsgColor = TextFormatting.RED;
-    public ContainerInventory inventory;
+    public final @NotNull ContainerInventory inventory;
     public final @Nullable ItemStack @NotNull [] oldArmorInventory = new ItemStack[4]; // Last tick's armor inventory, used for playing equip sounds at the right time.
-    public MenuAbstract inventorySlots;
-    public MenuAbstract craftingInventory;
-    public Gamemode gamemode = Gamemodes.SURVIVAL;
+    public @NotNull MenuAbstract inventoryMenu;
+    public @NotNull MenuAbstract containerMenu;
+    public @NotNull Gamemode gamemode = Gamemodes.SURVIVAL;
     //    public byte userType;
     public int score;
     public List<String> messageHistory = new ArrayList<>();
@@ -141,14 +141,15 @@ public abstract class Player
         this.timeUntilPortal = 20;
         this.inPortal = false;
         this.bobberEntity = null;
-        this.inventorySlots = new MenuInventory(this.inventory);
-        this.craftingInventory = this.inventorySlots;
+        this.inventoryMenu = new MenuInventory(this.inventory);
+        this.containerMenu = this.inventoryMenu;
         TilePos spawnPoint = world.getSpawnPoint();
         moveTo((double) spawnPoint.x + 0.5D, spawnPoint.y + 1, (double) spawnPoint.z + 0.5D, 0.0F, 0.0F);
 //        rotOffs = 180F;
         this.fireImmuneTicks = 20;
         setTextureIdentifier("minecraft", "char");
         this.noAI = false;
+        this.yRot = 180.0f;
     }
 
     @Override
@@ -311,9 +312,9 @@ public abstract class Player
             this.heldObject.heldTick(this.world, this);
         }
 
-        if (!this.world.isClientSide && this.craftingInventory != null && !this.craftingInventory.stillValid(this)) {
+        if (!this.world.isClientSide && this.containerMenu != null && !this.containerMenu.stillValid(this)) {
             closeScreen();
-            this.craftingInventory = this.inventorySlots;
+            this.containerMenu = this.inventoryMenu;
         }
         addStat(StatList.minutesPlayedStat, 1);
         if (this.vehicle == null) {
@@ -327,7 +328,7 @@ public abstract class Player
     }
 
     protected void closeScreen() {
-        this.craftingInventory = this.inventorySlots;
+        this.containerMenu = this.inventoryMenu;
     }
 
     @Override
@@ -476,7 +477,7 @@ public abstract class Player
         }
 
         if (!this.world.getGameRuleValue(GameRules.KEEP_INVENTORY)) {
-            this.craftingInventory.onCraftGuiClosed(this);
+            this.containerMenu.onCraftGuiClosed(this);
             this.inventory.dropAllItems();
         }
         if (this.heldObject != null) { // TODO consider whether making the held object kept with keep inventory is a good idea
@@ -1087,9 +1088,9 @@ public abstract class Player
     @Override
     public void remove() {
         super.remove();
-        this.inventorySlots.onCraftGuiClosed(this);
-        if (this.craftingInventory != null) {
-            this.craftingInventory.onCraftGuiClosed(this);
+        this.inventoryMenu.onCraftGuiClosed(this);
+        if (this.containerMenu != null) {
+            this.containerMenu.onCraftGuiClosed(this);
         }
     }
 
@@ -1193,7 +1194,7 @@ public abstract class Player
         setupScale();
         TilePos bedPos = this.bedTilePos;
         Block<?> b;
-        if (bedPos != null && (b = this.world.getBlock(bedPos)) != null && b.getLogic() instanceof BlockLogicBed) {
+        if (bedPos != null && (b = this.world.getBlockType(bedPos)) != null && b.getLogic() instanceof BlockLogicBed) {
             BlockLogicBed.setBedOccupied(this.world, bedPos, false);
             TilePos emptyPos = BlockLogicBed.getNearestEmptyTilePos(this.world, bedPos, 0);
             if (emptyPos == null) {
@@ -1224,7 +1225,7 @@ public abstract class Player
         chunkProvider.prepareChunk(coords.x + 3 >> 4, coords.z - 3 >> 4);
         chunkProvider.prepareChunk(coords.x - 3 >> 4, coords.z + 3 >> 4);
         chunkProvider.prepareChunk(coords.x + 3 >> 4, coords.z + 3 >> 4);
-        if (Block.hasLogicClass(world.getBlock(coords), BlockLogicBed.class)) {
+        if (Block.hasLogicClass(world.getBlockType(coords), BlockLogicBed.class)) {
             return BlockLogicBed.getNearestEmptyTilePos(world, coords, 0);
         } else {
             return null;
@@ -1432,10 +1433,10 @@ public abstract class Player
         this.gamemode = gamemode;
 
         MenuInventory newContainer = gamemode.getInventoryMenu(this.inventory);
-        if (this.craftingInventory == this.inventorySlots) {
-            this.craftingInventory = newContainer;
+        if (this.containerMenu == this.inventoryMenu) {
+            this.containerMenu = newContainer;
         }
-        this.inventorySlots = newContainer;
+        this.inventoryMenu = newContainer;
         if (!gamemode.hasPlayerFlight()) {
             this.noPhysics = false;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrow.java b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrow.java
index 01138b4ce..7d732e303 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrow.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/projectile/ProjectileArrow.java
@@ -108,7 +108,7 @@ public class ProjectileArrow extends Projectile {
             this.xRotO = this.xRot = (float) ((Math.atan2(this.yd, f) * 180D) / Math.PI);
         }
         if (this.tilePos != null) {
-            Block<?> block = this.world.getBlock(this.tilePos);
+            Block<?> block = this.world.getBlockType(this.tilePos);
             if (block != null) {
                 AABBdc aabb = block.getCollisionAABB(this.world, this.tilePos);
                 if (aabb != null && aabb.containsPoint(new Vector3d(this.x, this.y, this.z))) {
@@ -117,7 +117,7 @@ public class ProjectileArrow extends Projectile {
             }
         }
         if (isGrounded() && this.tilePos != null) {
-            Block<?> b = this.world.getBlock(this.tilePos);
+            Block<?> b = this.world.getBlockType(this.tilePos);
             int meta = this.world.getBlockData(this.tilePos);
             if (b != this.inTile || meta != this.inData) {
                 setGrounded(false);
@@ -171,7 +171,7 @@ public class ProjectileArrow extends Projectile {
             }
         } else if (hitResult instanceof HitResult.Tile hitTile) {
             this.tilePos = new TilePos(hitTile.tilePos);
-            this.inTile = this.world.getBlock(hitTile.tilePos);
+            this.inTile = this.world.getBlockType(hitTile.tilePos);
             this.inData = this.world.getBlockData(hitTile.tilePos);
             this.xd = (float) (hitResult.location.x() - this.x);
             this.yd = (float) (hitResult.location.y() - this.y);
diff --git a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
index 2fb52e496..1f6db4191 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/vehicle/EntityMinecart.java
@@ -346,7 +346,7 @@ public class EntityMinecart extends Entity implements Container {
         final double maxSpeed = 0.4D;
         boolean didFurnacePush = false;
         final double d5 = 0.0078125D;
-        Block<?> block = this.world.getBlock(tilePos);
+        Block<?> block = this.world.getBlockType(tilePos);
         if (block != null && block.getLogic() instanceof BlockLogicRail rail) {
             Vector3dc vec3d = getPos(this.x, this.y, this.z);
             this.y = blockY;
diff --git a/game/core/src/main/java/net/minecraft/core/item/Item.java b/game/core/src/main/java/net/minecraft/core/item/Item.java
index 13bc34eff..5434bbcdd 100644
--- a/game/core/src/main/java/net/minecraft/core/item/Item.java
+++ b/game/core/src/main/java/net/minecraft/core/item/Item.java
@@ -27,12 +27,7 @@ import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-import java.util.ArrayList;
-import java.util.HashMap;
-import java.util.LinkedHashMap;
-import java.util.List;
-import java.util.Map;
-import java.util.Random;
+import java.util.*;
 import java.util.function.Supplier;
 
 @SuppressWarnings("unchecked")
@@ -266,18 +261,16 @@ public class Item implements ITaggable<Item>, IItemConvertible {
     /**
      * Called before a block is destroyed with this item. If the return value is false, the block won't be destroyed
      */
-    public boolean beforeBlockDestroyed(final @NotNull ItemStack selfStack, final @NotNull World world, final @NotNull Player player, final @NotNull Block<?> block, final @NotNull TilePos blockPos, final @NotNull Side side) {
+    public boolean beforeBlockDestroyed(final @NotNull ItemStack selfStack, final @NotNull World world, final @NotNull Player player, final @NotNull Block<?> block, final @NotNull TilePosc blockPos, final @NotNull Side side) {
         return true;
     }
 
     @Deprecated
     public final boolean onBlockDestroyed(final @NotNull World world, final @NotNull ItemStack selfStack, final int removedBlockId, final int x, final int y, final int z, final @NotNull Side side, final @NotNull Mob mob) {
-        Block<?> b = Blocks.getBlock(removedBlockId);
-        assert b != null;
-        return onBlockDestroyed(selfStack, world, mob, b, new TilePos(x, y, z), side);
+        return onBlockDestroyed(selfStack, world, mob, Objects.requireNonNull(Blocks.getBlock(removedBlockId)), new TilePos(x, y, z), side);
     }
 
-    public boolean onBlockDestroyed(final @NotNull ItemStack selfStack, final @NotNull World world, final @NotNull Mob mob, final @NotNull Block<?> removedBlock, final @NotNull TilePos blockPos, final @NotNull Side side) {
+    public boolean onBlockDestroyed(final @NotNull ItemStack selfStack, final @NotNull World world, final @NotNull Mob mob, final @NotNull Block<?> removedBlock, final @NotNull TilePosc blockPos, final @NotNull Side side) {
         return false;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBed.java b/game/core/src/main/java/net/minecraft/core/item/ItemBed.java
index 4cf988695..9c4a28593 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBed.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBed.java
@@ -28,8 +28,8 @@ public class ItemBed extends Item {
         if (world.isAirBlock(pos) && world.isAirBlock(pos2) && world.canPlaceOnSurfaceOfBlock(pos.down(new TilePos())) && world.canPlaceOnSurfaceOfBlock(pos2.down(new TilePos()))) {
             if (world.canBlockIdBePlacedAt(Blocks.BED.id(), pos, false, side) && selfStack.consumeItem(player)) {
                 world.playBlockSoundEffect(player, pos.x() + 0.5F, pos.y() + 0.5F, pos.z() + 0.5F, Blocks.BED, EnumBlockSoundEffectType.PLACE);
-                world.setBlockIdDataNotify(pos, Blocks.BED.id(), dir.getHorizontalIndex());
-                world.setBlockIdDataNotify(pos2, Blocks.BED.id(), dir.getHorizontalIndex() | 0b1000);
+                world.setBlockTypeDataNotify(pos, Blocks.BED, dir.getHorizontalIndex());
+                world.setBlockTypeDataNotify(pos2, Blocks.BED, dir.getHorizontalIndex() | 0b1000);
                 return true;
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBoat.java b/game/core/src/main/java/net/minecraft/core/item/ItemBoat.java
index 05c89c8c3..95329ef10 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBoat.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBoat.java
@@ -30,7 +30,7 @@ public class ItemBoat extends Item {
         if (rayCast instanceof HitResult.Tile hitTile) {
             TilePos pos = new TilePos(hitTile.tilePos);
             if (!world.isClientSide) {
-                if (world.getBlockId(pos) == Blocks.LAYER_SNOW.id()) {
+                if (world.getBlockType(pos) == Blocks.LAYER_SNOW) {
                     pos.y--;
                 }
                 EntityBoat boat = new EntityBoat(world, pos.x + 0.5F, pos.y + 1.0F, pos.z + 0.5F);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java b/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
index 459d54675..0d632252a 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
@@ -46,7 +46,7 @@ public class ItemBucket extends Item {
             return selfStack;
         }
 
-        Block<?> block = world.getBlock(rayCastPos);
+        Block<?> block = world.getBlockType(rayCastPos);
         if (block != null && !block.hasTag(BlockTags.PLACE_OVERWRITES) && !block.hasTag(BlockTags.BROKEN_BY_FLUIDS)) {
             Side side = hitTile.side;
             rayCastPos.x += side.getOffsetX();
@@ -63,11 +63,8 @@ public class ItemBucket extends Item {
                 world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, rayCastPos.x + 0.5F, rayCastPos.y + 0.5F, rayCastPos.z + 0.5F, "liquid.splash", 0.5f, 1.0f);
             }
             player.swingItem();
-            Block<?> block1 = world.getBlock(rayCastPos);
-            if (block1 != null) {
-                block1.dropWithCause(world, EnumDropCause.WORLD, rayCastPos, world.getBlockData(rayCastPos), null, null);
-            }
-            world.setBlockIdDataNotify(rayCastPos, this.blockToPlace.id(), 0);
+            world.getBlockType(rayCastPos).dropWithCause(world, EnumDropCause.WORLD, rayCastPos, world.getBlockData(rayCastPos), null, null);
+            world.setBlockTypeNotify(rayCastPos, this.blockToPlace);
             if (player.getGamemode().hasBlockConsumption()) {
                 return new ItemStack(Items.BUCKET);
             }
@@ -83,9 +80,9 @@ public class ItemBucket extends Item {
             return;
         }
         TilePos posAhead = blockPos.add(direction, new TilePos());
-        Block<?> b = world.getBlock(posAhead);
-        if (b == null || BlockTags.PLACE_OVERWRITES.appliesTo(b) || BlockTags.BROKEN_BY_FLUIDS.appliesTo(b)) {
-            world.setBlockIdNotify(posAhead, this.blockToPlace.id());
+        Block<?> b = world.getBlockType(posAhead);
+        if (b.hasTag(BlockTags.PLACE_OVERWRITES) || b.hasTag(BlockTags.BROKEN_BY_FLUIDS)) {
+            world.setBlockTypeNotify(posAhead, this.blockToPlace);
             selfStack.itemID = Items.BUCKET.id;
         }
     }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java b/game/core/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java
index 1904e2510..a13f2fa63 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java
@@ -1,5 +1,6 @@
 package net.minecraft.core.item;
 
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.animal.MobCow;
@@ -37,12 +38,12 @@ public class ItemBucketEmpty extends Item {
                 return selfStack;
             } else if (world.getBlockMaterial(hitTile.tilePos) == Materials.WATER && world.getBlockData(hitTile.tilePos) == 0) {
                 if (useBucket(player, new ItemStack(Items.BUCKET_WATER))) {
-                    world.setBlockIdNotify(hitTile.tilePos, 0);
+                    world.setBlockTypeNotify(hitTile.tilePos, Blocks.AIR);
                     player.swingItem();
                 }
             } else if (world.getBlockMaterial(hitTile.tilePos) == Materials.LAVA && world.getBlockData(hitTile.tilePos) == 0) {
                 if (useBucket(player, new ItemStack(Items.BUCKET_LAVA))) {
-                    world.setBlockIdNotify(hitTile.tilePos, 0);
+                    world.setBlockTypeNotify(hitTile.tilePos, Blocks.AIR);
                     player.swingItem();
                 }
             }
@@ -58,11 +59,11 @@ public class ItemBucketEmpty extends Item {
 
         TilePos shiftedPos = blockPos.add(direction, new TilePos());
         if (world.getBlockMaterial(shiftedPos) == Materials.WATER && world.getBlockData(shiftedPos) == 0) {
-            world.setBlockIdNotify(shiftedPos, 0);
+            world.setBlockTypeNotify(shiftedPos, Blocks.AIR);
             selfStack.itemID = Items.BUCKET_WATER.id;
             return;
         } else if (world.getBlockMaterial(shiftedPos) == Materials.LAVA && world.getBlockData(shiftedPos) == 0) {
-            world.setBlockIdNotify(shiftedPos, 0);
+            world.setBlockTypeNotify(shiftedPos, Blocks.AIR);
             selfStack.itemID = Items.BUCKET_LAVA.id;
             return;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemDiscMusic.java b/game/core/src/main/java/net/minecraft/core/item/ItemDiscMusic.java
index 40deff422..baa816515 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemDiscMusic.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemDiscMusic.java
@@ -28,7 +28,7 @@ public class ItemDiscMusic extends Item {
 
     @Override
     public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
-        if (world.getBlockId(blockPos) == Blocks.JUKEBOX.id() && world.getBlockData(blockPos) == 0) {
+        if (world.getBlockType(blockPos) == Blocks.JUKEBOX && world.getBlockData(blockPos) == 0) {
             if (!world.isClientSide) {
                 Blocks.JUKEBOX.getLogic().playRecord(world, new TilePos(blockPos), this.id);
                 world.playBlockEvent(null, blockPos, LevelListener.EVENT_JUKEBOX_TOGGLE, this.id);
@@ -42,8 +42,7 @@ public class ItemDiscMusic extends Item {
     @Override
     public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
         TilePos pos = blockPos.add(direction, new TilePos());
-        int b = world.getBlockId(pos);
-        if (b == Blocks.JUKEBOX.id() && world.getBlockData(pos) == 0) {
+        if (world.getBlockType(pos) == Blocks.JUKEBOX && world.getBlockData(pos) == 0) {
             Blocks.JUKEBOX.getLogic().playRecord(world, new TilePos(pos), this.id);
             world.playBlockEvent(null, pos, LevelListener.EVENT_JUKEBOX_TOGGLE, this.id);
             selfStack.consumeItem(null);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java b/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
index 5f273a557..aa381176a 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
@@ -41,8 +41,8 @@ public class ItemDoor extends Item {
 
         int isSolidBlockLeft = (isSupported(world, blockPos, leftDir, false) ? 1 : 0) + (isSupported(world, blockPos.up(new TilePos()), leftDir, false) ? 1 : 0);
         int isSolidBlockRight = (isSupported(world, blockPos, leftDir.getOpposite(), true) ? 1 : 0) + (isSupported(world, blockPos.up(new TilePos()), leftDir.getOpposite(), true) ? 1 : 0);
-        boolean isDoorLeft = world.getBlockId(blockPos.add(leftDir, new TilePos())) == this.doorBlockBottom.id() || world.getBlockId(blockPos.add(leftDir, new TilePos()).up(new TilePos())) == this.doorBlockTop.id();
-        boolean isDoorRight = world.getBlockId(blockPos.sub(leftDir, new TilePos())) == this.doorBlockBottom.id() || world.getBlockId(blockPos.sub(leftDir, new TilePos()).up(new TilePos())) == this.doorBlockTop.id();
+        boolean isDoorLeft = world.getBlockType(blockPos.add(leftDir, new TilePos())) == this.doorBlockBottom || world.getBlockType(blockPos.add(leftDir, new TilePos()).up(new TilePos())) == this.doorBlockTop;
+        boolean isDoorRight = world.getBlockType(blockPos.sub(leftDir, new TilePos())) == this.doorBlockBottom || world.getBlockType(blockPos.sub(leftDir, new TilePos()).up(new TilePos())) == this.doorBlockTop;
         boolean isMirrored = false;
 
         if (isDoorLeft && !isDoorRight) {
@@ -66,11 +66,11 @@ public class ItemDoor extends Item {
         }
 
         world.noNeighborUpdate = true;
-        world.setBlockIdDataNotify(blockPos, this.doorBlockBottom.id(), meta);
-        world.setBlockIdDataNotify(blockPos.up(new TilePos()), this.doorBlockTop.id(), meta);
+        world.setBlockTypeDataNotify(blockPos, this.doorBlockBottom, meta);
+        world.setBlockTypeDataNotify(blockPos.up(new TilePos()), this.doorBlockTop, meta);
         world.noNeighborUpdate = false;
-        world.notifyBlocksOfNeighborChange(blockPos, this.doorBlockBottom.id());
-        world.notifyBlocksOfNeighborChange(blockPos.up(new TilePos()), this.doorBlockTop.id());
+        world.notifyBlocksOfNeighborChange(blockPos, this.doorBlockBottom);
+        world.notifyBlocksOfNeighborChange(blockPos.up(new TilePos()), this.doorBlockTop);
         world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.doorBlockBottom, EnumBlockSoundEffectType.PLACE);
         this.doorBlockBottom.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
         this.doorBlockTop.onPlacedByMob(world, blockPos.up(new TilePos()), side, player, xHit, yHit);
@@ -95,8 +95,8 @@ public class ItemDoor extends Item {
 
         int isSolidBlockLeft = (isSupported(world, blockPos, lefDir, false) ? 1 : 0) + (isSupported(world, blockPos.up(new TilePos()), lefDir, false) ? 1 : 0);
         int isSolidBlockRight = (isSupported(world, blockPos, lefDir.getOpposite(), true) ? 1 : 0) + (isSupported(world, blockPos.up(new TilePos()), lefDir.getOpposite(), true) ? 1 : 0);
-        boolean isDoorLeft = world.getBlockId(blockPos.add(lefDir, new TilePos())) == this.doorBlockBottom.id() || world.getBlockId(blockPos.add(lefDir, new TilePos()).up(new TilePos())) == this.doorBlockTop.id();
-        boolean isDoorRight = world.getBlockId(blockPos.sub(lefDir, new TilePos())) == this.doorBlockBottom.id() || world.getBlockId(blockPos.sub(lefDir, new TilePos()).up(new TilePos())) == this.doorBlockTop.id();
+        boolean isDoorLeft = world.getBlockType(blockPos.add(lefDir, new TilePos())) == this.doorBlockBottom || world.getBlockType(blockPos.add(lefDir, new TilePos()).up(new TilePos())) == this.doorBlockTop;
+        boolean isDoorRight = world.getBlockType(blockPos.sub(lefDir, new TilePos())) == this.doorBlockBottom || world.getBlockType(blockPos.sub(lefDir, new TilePos()).up(new TilePos())) == this.doorBlockTop;
         boolean isMirrored = false;
 
         if (isDoorLeft && !isDoorRight) {
@@ -119,11 +119,11 @@ public class ItemDoor extends Item {
         }
 
         world.noNeighborUpdate = true;
-        world.setBlockIdDataNotify(blockPos, this.doorBlockBottom.id(), meta);
-        world.setBlockIdDataNotify(blockPos.up(new TilePos()), this.doorBlockTop.id(), meta);
+        world.setBlockTypeDataNotify(blockPos, this.doorBlockBottom, meta);
+        world.setBlockTypeDataNotify(blockPos.up(new TilePos()), this.doorBlockTop, meta);
         world.noNeighborUpdate = false;
-        world.notifyBlocksOfNeighborChange(blockPos, this.doorBlockBottom.id());
-        world.notifyBlocksOfNeighborChange(blockPos.up(new TilePos()), this.doorBlockTop.id());
+        world.notifyBlocksOfNeighborChange(blockPos, this.doorBlockBottom);
+        world.notifyBlocksOfNeighborChange(blockPos.up(new TilePos()), this.doorBlockTop);
         world.playBlockSoundEffect(null, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.doorBlockBottom, EnumBlockSoundEffectType.PLACE);
         this.doorBlockBottom.onPlacedOnSide(world, blockPos, direction.getSide(), 0.5, 0.5);
         this.doorBlockTop.onPlacedOnSide(world, blockPos.up(new TilePos()), direction.getSide(), 0.5, 0.5);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemDye.java b/game/core/src/main/java/net/minecraft/core/item/ItemDye.java
index 7d8e7d181..e8844b635 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemDye.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemDye.java
@@ -40,7 +40,7 @@ public class ItemDye extends Item {
 
     @Override
     public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xPlaced, double yPlaced) {
-        Block<?> block = world.getBlock(blockPos);
+        Block<?> block = world.getBlockType(blockPos);
         if (Block.hasLogicClass(block, BlockLogicSign.class) && world.getTileEntity(blockPos) instanceof TileEntitySign sign) {
             if ((DyeColor.WHITE.itemMeta - selfStack.getMetadata()) != sign.getColor().id) {
                 sign.setColor(TextFormatting.get(DyeColor.WHITE.itemMeta - selfStack.getMetadata()));
@@ -61,12 +61,12 @@ public class ItemDye extends Item {
             }
             if (block == Blocks.DIRT) {
                 if (!world.isClientSide) {
-                    if (Blocks.lightBlock[world.getBlockId(blockPos.up(queryPos))] <= 2) {
-                        int grass = Blocks.GRASS.id();
+                    if (world.getBlockType(blockPos.up(queryPos)).lightBlock() <= 2) {
+                        @NotNull Block<?> grass = Blocks.GRASS;
                         if (world.dimensionData.getWorldType() == WorldTypes.OVERWORLD_RETRO) {
-                            grass = Blocks.GRASS_RETRO.id();
+                            grass = Blocks.GRASS_RETRO;
                         }
-                        world.setBlockIdNotify(blockPos, grass);
+                        world.setBlockTypeNotify(blockPos, grass);
                         if (player == null || player.getGamemode().hasBlockConsumption()) {
                             selfStack.stackSize--;
                         }
@@ -76,9 +76,9 @@ public class ItemDye extends Item {
             }
             if (block == Blocks.DIRT_SCORCHED) {
                 if (!world.isClientSide) {
-                    if (Blocks.lightBlock[world.getBlockId(blockPos.up(queryPos))] <= 2) {
-                        int grass = Blocks.GRASS_SCORCHED.id();
-                        world.setBlockIdNotify(blockPos, grass);
+                    if (world.getBlockType(blockPos.up(queryPos)).lightBlock() <= 2) {
+                        @NotNull Block<?> grass = Blocks.GRASS_SCORCHED;
+                        world.setBlockTypeNotify(blockPos, grass);
                         if (player == null || player.getGamemode().hasBlockConsumption()) {
                             selfStack.stackSize--;
                         }
@@ -100,37 +100,36 @@ public class ItemDye extends Item {
                             p.x += itemRand.nextInt(3) - 1;
                             p.y += ((itemRand.nextInt(3) - 1) * itemRand.nextInt(3)) / 2;
                             p.z += itemRand.nextInt(3) - 1;
-                            int id1 = world.getBlockId(p.down(queryPos));
-                            if (Blocks.blocksList[id1] == null || !Blocks.blocksList[id1].hasTag(BlockTags.GROWS_FLOWERS)) {
+                            if (!world.getBlockType(p.down(queryPos)).hasTag(BlockTags.GROWS_FLOWERS)) {
                                 continue label0;
                             }
                         }
 
-                        if (world.getBlockId(p) != 0) {
+                        if (world.getBlockType(p) != Blocks.AIR) {
                             continue;
                         }
                         if (itemRand.nextInt(10) != 0) {
-                            if (world.getBlockId(p.down(queryPos)) == Blocks.DIRT_SCORCHED.id() ||
-                                world.getBlockId(p.down(queryPos)) == Blocks.DIRT_SCORCHED_RICH.id())
-                                world.setBlockIdNotify(p, Blocks.SPINIFEX.id());
+                            if (world.getBlockType(p.down(queryPos)) == Blocks.DIRT_SCORCHED ||
+                                world.getBlockType(p.down(queryPos)) == Blocks.DIRT_SCORCHED_RICH)
+                                world.setBlockTypeNotify(p, Blocks.SPINIFEX);
                             else
-                                world.setBlockIdNotify(p, Blocks.TALLGRASS.id());
+                                world.setBlockTypeNotify(p, Blocks.TALLGRASS);
                             continue;
                         }
                         int r = itemRand.nextInt(12);
                         Biome biome = world.getBlockBiome(p);
                         if (r < 1) {
-                            world.setBlockIdNotify(p, Blocks.FLOWER_YELLOW.id());
+                            world.setBlockTypeNotify(p, Blocks.FLOWER_YELLOW);
                         } else if (r < 2) {
-                            world.setBlockIdNotify(p, Blocks.FLOWER_RED.id());
+                            world.setBlockTypeNotify(p, Blocks.FLOWER_RED);
                         } else if (r < 4 && (biome == Biomes.OVERWORLD_BIRCH_FOREST || biome == Biomes.OVERWORLD_SEASONAL_FOREST)) {
-                            world.setBlockIdNotify(p, Blocks.FLOWER_PINK.id());
+                            world.setBlockTypeNotify(p, Blocks.FLOWER_PINK);
                         } else if (r < 6 && (biome == Biomes.OVERWORLD_MEADOW || biome == Biomes.OVERWORLD_BOREAL_FOREST || biome == Biomes.OVERWORLD_SHRUBLAND)) {
-                            world.setBlockIdNotify(p, Blocks.FLOWER_PURPLE.id());
+                            world.setBlockTypeNotify(p, Blocks.FLOWER_PURPLE);
                         } else if (r < 8 && (biome == Biomes.OVERWORLD_FOREST || biome == Biomes.OVERWORLD_SWAMPLAND || biome == Biomes.OVERWORLD_RAINFOREST || biome == Biomes.OVERWORLD_GRASSLANDS || biome == Biomes.OVERWORLD_CAATINGA)) {
-                            world.setBlockIdNotify(p, Blocks.FLOWER_LIGHT_BLUE.id());
+                            world.setBlockTypeNotify(p, Blocks.FLOWER_LIGHT_BLUE);
                         } else if (r < 10 && (biome == Biomes.OVERWORLD_PLAINS || biome == Biomes.OVERWORLD_GRASSLANDS || biome == Biomes.OVERWORLD_OUTBACK || biome == Biomes.OVERWORLD_OUTBACK_GRASSY)) {
-                            world.setBlockIdNotify(p, Blocks.FLOWER_ORANGE.id());
+                            world.setBlockTypeNotify(p, Blocks.FLOWER_ORANGE);
                         }
                     }
                 }
